<?php


namespace Service;


use Util\Mail\Core\SmtpMail;
use Zend\Mime\Message as ZendMimeMessage;
use Zend\Mime\Part as ZendMimePart;

class SendEmail
{

    private $sender;
    private $smtpMail;

    public function __construct(\Util\Mail\Core\SmtpMail $smtpMail, $smtpUsername)
    {
        $this->sender   = $smtpUsername;
        $this->smtpMail = $smtpMail;
    }
    protected function encodeAndSend($to, $subject, $message)
    {
        $message        = utf8_decode($message);
        $mimePart       = new ZendMimePart($message);
        $mimeMessage    = new ZendMimeMessage();
        $mimePart->type = 'text/html';
        $mimeMessage->setParts(array($mimePart));
        $this->sendHtml($to, $subject, $mimeMessage);
    }

    protected function sendHtml($to, $subject, $message)
    {
        $this->smtpMail->setFrom('zmart@teknisa.com');
        $this->smtpMail->setTo($to);
        $this->smtpMail->setSubject($subject);
        $this->smtpMail->setBody($message);
        $this->smtpMail->sendHtml();
    }

    public function sendArrayMessagesByEmail($subject,$arrayMessagesByEmail)
    {
        $emailSent = array();
        $emailSentError = array();
        foreach ($arrayMessagesByEmail as $email => $messages) {
            try {
                $message = implode("\n\n", $messages);
                $this->sendHtml($email, $subject, $message);
                $emailSent[] = $email;
            } catch (\Exception $e) {
                $emailSentError[] = $email;
            }
        }
        return array($emailSent,$emailSentError);
    }
}
