/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODUTOSEG                                               */
/* Tabela : PRODUTOSEG                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODUTOSEG'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRODUTOSEG
GO

CREATE TRIGGER DTULTATU_PRODUTOSEG
ON PRODUTOSEG
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODUTOSEG', null, 'CDSEGMER=' + CDSEGMER + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODUTOSEG
      SET DTULTATUPSEG = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(PRODUTOSEG.CDSEGMER,0)    = ISNULL(INSERTED.CDSEGMER,0)) AND
            (ISNULL(PRODUTOSEG.CDPRODUTO,0)   = ISNULL(INSERTED.CDPRODUTO,0)) AND
            (ISNULL(PRODUTOSEG.IDPROSEGATIV,0)= ISNULL(INSERTED.IDPROSEGATIV,0));
   END;
END;
GO


UPDATE PRODUTOSEG SET DTULTATUPSEG = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPSEG IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPSEG' and
            type = 'D')
   ALTER TABLE PRODUTOSEG DROP CONSTRAINT DEFAULT_DTULTATUPSEG
GO

ALTER TABLE PRODUTOSEG ADD CONSTRAINT DEFAULT_DTULTATUPSEG
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPSEG
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODUTOSEG','4.11.194';
GO

