import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";

export class CardDetail extends ChartViewAbstract implements ChartViewInterface {
    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        const cardHeight = dashboard.height * 120;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].children[0].text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; height: " + (cardHeight - 30) + "px";
        widget[0].color = dashboard.color;
        widget[0].widget.color = dashboard.color;
        widget[0].height = cardHeight + "px";
        widget[0].children[2].children[0].color = dashboard.color;
        widget[0].children[2].children[1].color = dashboard.color;
        return widget;
    }
    public getCharts(charts: any) {
        return charts;
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        return charts;
    }

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        if (cleanValues.chartXAxisField_GERAL) {
            cleanValues.chartXAxisField = cleanValues.chartXAxisField_GERAL;
        }
        cleanValues.yKeys = cleanValues.yKeys_properties;
        cleanValues.cardMask = cleanValues.cardMask_card1;

        return cleanValues;
    }

    public getEditData(viewData: any) {
        if (Array.isArray(viewData.serieColors)) {
            viewData.originSerieColors = viewData.serieColors;
        }
        if (viewData.chartXAxisField) {
            viewData.chartXAxisField_GERAL = viewData.chartXAxisField;
        }
        if (viewData.yKeys) {
            viewData.yKeys_properties = viewData.yKeys;
        }
        if (viewData.cardMask) {
            viewData.cardMask_card1 = viewData.cardMask;
        }
        return viewData;
    }

    public getWidgetDashboard(widget: any, dashboard: any) {
        if (dashboard.w) {
            widget[0].children[1].textResize.fontSize = (dashboard.w * 11);
            widget[0].children[2].children[0].children[1].textResize.fontSize = (dashboard.w * 5);
            widget[0].children[2].children[1].children[1].textResize.fontSize = (dashboard.w * 5);
        }
        return widget;
    }
}
